<?php
//recupération de la version de l'OS
function getOS() { 
    global $user_agent;
    $u_agent = $_SERVER['HTTP_USER_AGENT'];
    $os_platform  = "Plate-forme OS inconnue";
    $os_array     = array(
        '/Windows NT 10.0/i'    =>  'Windows 10',
        '/Windows NT 6.3/i'     =>  'Windows 8.1',
        '/Windows NT 6.2/i'     =>  'Windows 8',
        '/Windows NT 6.1/i'     =>  'Windows 7',
        '/Windows NT 6.0/i'     =>  'Windows Vista',
        '/Windows NT 5.2/i'     =>  'Windows Server 2003/XP x64',
        '/Windows NT 5.1/i'     =>  'Windows XP',
        '/Windows xp/i'         =>  'Windows XP',
        '/Windows NT 5.0/i'     =>  'Windows 2000',
        '/Windows ME/i'         =>  'Windows ME',
        '/win98/i'              =>  'Windows 98',
        '/win95/i'              =>  'Windows 95',
        '/win16/i'              =>  'Windows 3.11',
        '/macintosh|mac os x/i' =>  'Mac OS X',
        '/mac_powerpc/i'        =>  'Mac OS 9',
        '/Linux/i'              =>  'Linux',
        '/Ubuntu/i'             =>  'Ubuntu',
        '/Voyager/i'            =>  'Voyager',
        '/Fedora/i'             =>  'Fedora',
        '/Iphone/i'             =>  'iPhone',
        '/Ipod/i'               =>  'iPod',
        '/Ipad/i'               =>  'iPad',
        '/Android/i'            =>  'Android',
        '/Blackberry/i'         =>  'BlackBerry',
        '/Webos/i'              =>  'Mobile'
    );
    foreach ($os_array as $regex => $value) {
        if (preg_match($regex, $u_agent)) {
            $os_platform = $value;
        }
        return $os_platform;
    }
}
$os=getOS();

//recupération la version du navigateur
function getBrowser() {
    $u_agent = $_SERVER['HTTP_USER_AGENT'];
    //recuperation de l'architecture
    $osarch = explode (';', $u_agent);
    $bname = 'Unknown';
    $platform = 'Unknown';
    $version= "";
    //obtenir le nom de l'agent d'utilisateur 
    if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)) {
        $bname = 'Internet Explorer';
        $ub = "MSIE";
        $arch = substr($osarch[1],-2);
    } elseif(preg_match('/Trident/i',$u_agent)) { // this condition is for IE11
        $bname = 'Internet Explorer';
        $ub = "rv";
        $arch = substr($osarch[1],-2);
    } elseif(preg_match('/Firefox/i',$u_agent)) {
        $bname = 'Mozilla Firefox';
        $ub = "Firefox";
        $arch = substr($osarch[2],-2);
    } elseif(preg_match('/Chrome/i',$u_agent)) {
        $bname = 'Google Chrome';
        $ub = "Chrome";
        $arch = substr($osarch[1],-2);
    } elseif(preg_match('/Safari/i',$u_agent)) {
        $bname = 'Apple Safari';
        $ub = "Safari";
        $arch = substr($osarch[1],-2);
    } elseif(preg_match('/Opera/i',$u_agent)) {
        $bname = 'Opera';
        $ub = "Opera";
        $arch = substr($osarch[2],-2);
    } elseif(preg_match('/Netscape/i',$u_agent)) {
        $bname = 'Netscape';
        $ub = "Netscape";
        $arch = substr($osarch[2],-2);
    }
    //obtenir le bon numéro de version
    $known = array('Version', $ub, 'other');
    $pattern = '#(?<browser>' . join('|', $known) .
     ')[/|: ]+(?<version>[0-9.|a-zA-Z.]*)#';
    if (!preg_match_all($pattern, $u_agent, $matches)) {
        //aucune correspondance de numéro
    }
    $i = count($matches['browser']);
    if ($i != 1) {
        if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
            $version= $matches['version'][0];
        }
        else {
            $version= $matches['version'][1];
        }
    }
    else {
        $version= $matches['version'][0];
    }
    //vérifier le numéro
    if ($version==null || $version=="") {$version="?";}
    return array(
        'userAgent' => $u_agent,
        'name'      => $bname,
        'version'   => $version,
        'platform'  => $platform,
        'arch'      => $arch,
        'pattern'   => $pattern
    );
}
$ua=getBrowser();

//récupération de l'heure courante
$date_courante = date("Y-m-d H:i:s");

//récupération de l'adresse IP du client (on cherche d'abord à savoir si il est derrière un proxy)
if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
  $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
}
elseif(isset($_SERVER['HTTP_CLIENT_IP'])) {
  $ip  = $_SERVER['HTTP_CLIENT_IP'];
}
else {
  $ip = $_SERVER['REMOTE_ADDR'];
}

//récupération du domaine du client
$host = gethostbyaddr($ip);

//récupération de la page precédente
if (isset($_SERVER['HTTP_REFERER'])) {
    if (eregi($_SERVER['HTTP_HOST'], $_SERVER['HTTP_REFERER'])) {
    $referer ='';
    }
    else {
    $referer = $_SERVER['HTTP_REFERER'];
    }
}
else {
  $referer ='';
}

//récupération du nom de la page courante ainsi que ses arguments
if ($_SERVER['QUERY_STRING'] == "") {
  $page_courante = $_SERVER['PHP_SELF'];
}
else {
  $page_courante = $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'];
}

// récupération du pays
function DetectLocale() {
    $Language = str_replace('-', '_', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
    if (preg_match('/[a-z]{2}_[A-Z]{2}/', $Language, $MatchesArray)) {
        echo '<p><strong>Language : </strong>'.$MatchesArray[0].'<br/>';
    }
}

//affichage des données
echo '<div id="titreAdmin">Visualisation des paramètres du visiteur
<p>Visualiser toutes les informations de votre client (Navigateur, OS, langue).</p></div>
<div id="contentAdmin">';
$langue=DetectLocale();
echo '<strong>User agent : </strong>'.$ua['userAgent'].'<br/><br/>
<strong>Adresse IP : </strong>'.$ip.' <br/>
<strong>Hôte : </strong>'.$host.'<br/><br/>
<strong>Navigateur : </strong>'.$ua['name'] . " " . $ua['version'].'<br/>
<strong>OS : </strong>'.$os.' - '.$ua['arch'].'bits<br/><br/>
<strong>Page courante : </strong>'.$page_courante.' <br/>
<strong>Page précédente :</strong>'.$referer.'<br/></p>
</div>';
?>